// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"
#include "malloc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib, "Decode1D.lib")

extern "C" __declspec(dllimport) WORD _stdcall De1DInit();
extern "C" __declspec(dllimport) WORD _stdcall De1DScan();
extern "C" __declspec(dllimport) WORD _stdcall De1DCleanUp();
extern "C" __declspec(dllimport) WORD _stdcall De1DGetCount();
extern "C" __declspec(dllimport) WORD _stdcall De1DGetType(WORD CodeIndex);
extern "C" __declspec(dllimport) WORD _stdcall De1DGetStrLen(WORD CodeIndex);
extern "C" __declspec(dllimport) WORD _stdcall De1DGetCharAt(WORD CodeIndex, WORD CharIndex);
extern "C" __declspec(dllimport) WORD _stdcall De1DGetRect(WORD CodeIndex, DWORD *P1, DWORD *P2, DWORD *P3, DWORD *P4);
extern "C" __declspec(dllimport) WORD _stdcall De1DLoadFromFile(LPCTSTR FileName, WORD ImgFormat);
extern "C" __declspec(dllimport) WORD _stdcall De1DGetNumOfPages();
extern "C" __declspec(dllimport) WORD _stdcall De1DSetPage(WORD PageIndex);
extern "C" __declspec(dllimport) WORD _stdcall De1DSetThreshold(WORD Threshold);
extern "C" __declspec(dllimport) WORD _stdcall De1DSetRegion(WORD Left, WORD Top, WORD Right, WORD Bottom);
extern "C" __declspec(dllimport) WORD _stdcall De1DScanType(WORD CodeType, WORD Enabled);
extern "C" __declspec(dllimport) WORD _stdcall De1DSetLimit(double QuietZoneSize, double MinBarHeight, double MaxBarHeight);
extern "C" __declspec(dllimport) WORD _stdcall De1DSetKey(LPCTSTR lpKey);
extern "C" __declspec(dllimport) WORD _stdcall De1DLoadFromMem(BYTE *Buffer, DWORD Size, WORD ImgFormat);
extern "C" __declspec(dllimport) WORD _stdcall De1DGetImgSize(WORD *Width, WORD *Height);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_BUTTON_IMG_APPLY, m_btnImgInfoApply);
	DDX_Control(pDX, IDC_COMBO_FILE_LOC, m_cbxFileLocation);
	DDX_Control(pDX, IDC_CHECK_EAN8, m_chkEAN8);
	DDX_Control(pDX, IDC_CHECK_EAN13, m_chkEAN13);
	DDX_Control(pDX, IDC_EDIT_RHEIGHT, m_txtRHeight);
	DDX_Control(pDX, IDC_EDIT_RWIDTH, m_txtRWidth);
	DDX_Control(pDX, IDC_EDIT_RTOP, m_txtRTop);
	DDX_Control(pDX, IDC_EDIT_RLEFT, m_txtRLeft);
	DDX_Control(pDX, IDC_COMBO1_PAGES, m_cbxPages);
	DDX_Control(pDX, IDC_EDIT3, m_txtImgPages);
	DDX_Control(pDX, IDC_EDIT_HEIGHT, m_txtImgHeight);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_txtImgWidth);
	DDX_Control(pDX, IDC_COMBO_MAX_HEIGHT, m_cbxMaxHeight);
	DDX_Control(pDX, IDC_COMBO_MIN_HEIGHT, m_cbxMinHeight);
	DDX_Control(pDX, IDC_COMBO_QUIETZONE, m_cbxQuietZone);
	DDX_Control(pDX, IDC_EDIT_THRESHOLD, m_txtThreshold);
	DDX_Control(pDX, IDC_CHECK_IT25, m_chkIT25);
	DDX_Control(pDX, IDC_CHECK7, m_chkUPCE);
	DDX_Control(pDX, IDC_CHECK_UPCA, m_chkUPCA);
	DDX_Control(pDX, IDC_CHECK_EAN128, m_chkEAN128);
	DDX_Control(pDX, IDC_CHECK_CODE128, m_chkCode128);
	DDX_Control(pDX, IDC_CHECK_CODE39, m_chkCode39);
	DDX_Control(pDX, IDC_EDIT10, m_BarcodeInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_SO_APPLY, OnBtnSoApply)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnButtonScan)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_IMG_APPLY, OnButtonImgApply)
	ON_CBN_SELCHANGE(IDC_COMBO1_PAGES, OnSelchangeCombo1Pages)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_chkCode39.SetCheck(1);
	m_chkCode128.SetCheck(1);
	m_chkEAN128.SetCheck(1);
	m_chkEAN13.SetCheck(1);
	m_chkEAN8.SetCheck(1);
	m_chkUPCA.SetCheck(1);
	m_chkUPCE.SetCheck(1);
	m_chkIT25.SetCheck(1);
	m_txtThreshold.SetWindowText("128");
	m_cbxQuietZone.SetCurSel(1);
	m_cbxMinHeight.SetCurSel(0);
	m_cbxMaxHeight.SetCurSel(0);
	m_cbxFileLocation.SetCurSel(1);

	m_bCode39 = TRUE; 
	m_bCode128 = TRUE; 
	m_bEAN128 = TRUE; 
	m_bEAN13 = TRUE; 
	m_bEAN8 = TRUE; 
	m_bUPCA = TRUE; 
	m_bUPCE = TRUE; 
	m_bIT25 = TRUE; 
	m_nThreshold = 128;
	m_dQuietZone = 10;
	m_dMinBarHeight = 1;
	m_dMaxBarHeight = 5;
	m_bDiskFile = TRUE;

	m_btnImgInfoApply.EnableWindow(false);

	// Make sure De1DInit is called before you scan the barcode images
    // This function call is mandatory.
	De1DInit();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlg::OnOK() 
{
	// TODO: Add extra validation here

	// Make sure De1DCleanUp is called after you finish scanning all barcode images
    // This function call is mandatory to free the memory.
	De1DCleanUp();

	CDialog::OnOK();
}

WORD CDemoDlg::GetImgFormat(LPCSTR ImgName)
{
	char buf[200];
	char FileExt[20];
	int i, count, len;

	// get the extension part of a file name
	strcpy(buf, ImgName);
	len = strlen(buf);
	count = 0;
	for (i = len - 1; i >= 0; i--)
	{
		if (buf[i] == '.')
			break;
		else
		{
			if ((buf[i] >= 'A') && (buf[i] <= 'Z'))
				FileExt[count++] = buf[i] - 'A' + 'a';
			else
				FileExt[count++] = buf[i];
		}
	}
	FileExt[count] = '\0';

	for (i = 0; i < (count/2); i++)
	{
		char tmp = FileExt[i];
		FileExt[i] = FileExt[count - 1 - i];
		FileExt[count - 1 - i] = tmp;
	}

	if (strcmp(FileExt, "bmp") == 0)
		return 1;
	else if (strcmp(FileExt, "gif") == 0)
		return 2;
	else if (strcmp(FileExt, "ico") == 0)
		return 3;
	else if (strcmp(FileExt, "jpg") == 0)
		return 4;
	else if (strcmp(FileExt, "png") == 0)
		return 5;
	else if ((strcmp(FileExt, "tif") == 0) || (strcmp(FileExt, "tiff") == 0))
		return 6;
	else if (strcmp(FileExt, "wmf") == 0)
		return 7;
	else
		return -1;

}

void CDemoDlg::OnButtonScan() 
{
	// TODO: Add your control notification handler code here
	WORD result;

	for (int k = 0; k < 1; k++)
	{
		// enable/disable scanning Code39
		if (m_bCode39)
			De1DScanType(0, 1);
		else
			De1DScanType(0, 0);

		// enable/disable scanning Code128
		if (m_bCode128)
			De1DScanType(1, 1);
		else
			De1DScanType(1, 0);

		// enable/disable scanning EAN128
		if (m_bEAN128)
			De1DScanType(2, 1);
		else
			De1DScanType(2, 0);

		// enable/disable scanning EAN13
		if (m_bEAN13)
			De1DScanType(3, 1);
		else
			De1DScanType(3, 0);

		// enable/disable scanning EAN8
		if (m_bEAN8)
			De1DScanType(4, 1);
		else
			De1DScanType(4, 0);

		// enable/disable scanning UPCA
		if (m_bUPCA)
			De1DScanType(5, 1);
		else
			De1DScanType(5, 0);

		// enable/disable scanning UPCE
		if (m_bUPCE)
			De1DScanType(6, 1);
		else
			De1DScanType(6, 0);

		// enable/disable scanning Interleaved 25
		if (m_bIT25)
			De1DScanType(7, 1);
		else
			De1DScanType(7, 0);

		// For full version library, pass the 10-digit license key to this function
		// Sample code:
		// result = De1DSetKey("123456-7890");
		result = De1DSetKey("DEMO");

		result = De1DSetThreshold(m_nThreshold);

		result = De1DSetLimit(m_dQuietZone, m_dMinBarHeight, m_dMaxBarHeight);

		result = De1DSetRegion(m_nRLeft, m_nRTop, m_nRRight, m_nRBottom);

		result = De1DScan();

		int count = De1DGetCount();

		if (count > 0)
		{
			CString tmp;
			CString OneCode;
			CString info;
			int type;
			if (count == 1)
				tmp.Format("1 Barcode Found\r\n");
			else
				tmp.Format("%d Barcodes Found\r\n", count);

			info = tmp;
			for(int i = 1; i <= count; i++)
			{
				OneCode.Format("[Barcode %d]\r\n", i);

				// barcode type
				type = De1DGetType(i - 1);
				if (type == 0)
					OneCode = OneCode + "Type: Code39\r\n";
				else if (type == 1)
					OneCode = OneCode + "Type: Code128\r\n";
				else if (type == 2)
					OneCode = OneCode + "Type: EAN128\r\n";
				else if (type == 3)
					OneCode = OneCode + "Type: EAN13\r\n";
				else if (type == 4)
					OneCode = OneCode + "Type: EAN8\r\n";
				else if (type == 5)
					OneCode = OneCode + "Type: UPCA\r\n";
				else if (type == 6)
					OneCode = OneCode + "Type: UPCE\r\n";
				else if (type == 7)
					OneCode = OneCode + "Type: Interleaved 25\r\n";

				// barcode boundary rectangle
				DWORD P[4];
				De1DGetRect(i - 1, &P[0], &P[1], &P[2], &P[3]);
				for (int j = 1; j <= 4; j++)
				{
					tmp.Format("Point %d: (%d, %d)\r\n", j, (P[j - 1] >> 16) & 0xFFFF, P[j - 1] & 0xFFFF);
					OneCode = OneCode + tmp;
				}

				// the string encoded by this barcode
				int len = De1DGetStrLen(i - 1);
				tmp.Format("String length:%d\r\n", len);
				OneCode = OneCode + tmp;
				OneCode = OneCode + "String:";
				for (j = 0; j < len; j++)
				{
					int ch = De1DGetCharAt(i - 1, j);
					if ((type == 1 || type == 2) &&
						(ch >= 201) && (ch <= 204))
					{
						// code128 or EAN128
						// FNC 1, FNC 2, FNC 3 or FNC 4
						tmp.Format("FNC %d", (ch - 200));
						OneCode = OneCode + tmp;	
					}
					else
					{
						tmp.Format("%c", ch);
						OneCode = OneCode + tmp;
					}
				}
				tmp.Format("\r\n\r\n");
				OneCode = OneCode + tmp;

				info = info + OneCode;
			}
			m_BarcodeInfo.SetWindowText(info);
		}
		else
		{
			m_BarcodeInfo.SetWindowText("No barcode found.");
		}
	}

	return;
}

void CDemoDlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here
	CFile f;
	WORD w, h;

	CFileDialog fd(TRUE);
	
	if (fd.DoModal() != IDOK)
		return;

	// Image file name
	CString sFileName = fd.GetPathName();

	fd.DestroyWindow();

	// Image format
	m_nImgFormat = GetImgFormat(sFileName);

	if (m_nImgFormat == -1)
		// invalid image format
		return;

	// Load image file into DLL library
	int result;
	if (m_bDiskFile)
	{
		result = De1DLoadFromFile(sFileName, m_nImgFormat);
	}
	else
	{
		HANDLE fh = CreateFile(sFileName,
						       GENERIC_READ,
							   0,
							   NULL,
							   OPEN_EXISTING, 
							   FILE_ATTRIBUTE_NORMAL, 
							   NULL);
    
		DWORD fs = GetFileSize(fh, NULL);
		byte *buf = (byte *)malloc(fs * sizeof(byte));
		DWORD lRead;
		BOOL fRead = ReadFile(fh, buf, fs, &lRead, NULL);
		result = De1DLoadFromMem(buf, fs, m_nImgFormat);
		free(buf);
		CloseHandle(fh);
	}

	if (result == 1)
	{
		// OK
		if ((m_nImgFormat == 2) || (m_nImgFormat == 6))
		{
			// TIF or GIF file
			// How many pages
			int p = De1DGetNumOfPages();
			CString tmp;
			tmp.Format("%d", p);
			m_txtImgPages.SetWindowText(tmp);
			for(int i = 0; i <= m_cbxPages.GetCount() - 1; i++)
				m_cbxPages.DeleteString(i);

			// Update page list
			for(i = 1; i <= p; i++)
			{
				tmp.Format("%d", i);
				m_cbxPages.AddString(tmp);
			}
			m_cbxPages.SetCurSel(0);

			result = De1DSetPage(0);

			if (result == 1)
			{
				De1DGetImgSize(&w, &h);
		
				CString tmp;
				tmp.Format("%d", w);
				m_txtImgWidth.SetWindowText(tmp);
				m_txtRWidth.SetWindowText(tmp);

				tmp.Format("%d", h);
				m_txtImgHeight.SetWindowText(tmp);
				m_txtRHeight.SetWindowText(tmp);

				m_txtRLeft.SetWindowText("0");
				m_txtRTop.SetWindowText("0");

				m_nRLeft = 0;
				m_nRTop = 0;
				m_nRRight = w - 1;
				m_nRBottom = h - 1;
				m_nImgWidth = w;
				m_nImgHeight = h;
			}
		}
		else
		{
			m_txtImgPages.SetWindowText("1");
			for(int i = 0; i <= m_cbxPages.GetCount() - 1; i++)
				m_cbxPages.DeleteString(i);

			// Other image formats
			m_txtImgPages.SetWindowText("");
			m_cbxPages.Clear();

			De1DGetImgSize(&w, &h);

			CString tmp;
			tmp.Format("%d", w);
			m_txtImgWidth.SetWindowText(tmp);
			m_txtRWidth.SetWindowText(tmp);

			tmp.Format("%d", h);
			m_txtImgHeight.SetWindowText(tmp);
			m_txtRHeight.SetWindowText(tmp);

			m_txtRLeft.SetWindowText("0");
			m_txtRTop.SetWindowText("0");

			m_nRLeft = 0;
			m_nRTop = 0;
			m_nRRight = w - 1;
			m_nRBottom = h - 1;

			m_nImgWidth = w;
			m_nImgHeight = h;
		}
		m_btnImgInfoApply.EnableWindow(true);
	}
	else
	{
		m_btnImgInfoApply.EnableWindow(false);
	}
}

void CDemoDlg::OnBtnSoApply() 
{
	// TODO: Add your control notification handler code here
	m_bCode39 = m_chkCode39.GetCheck(); 
	m_bCode128 = m_chkCode128.GetCheck(); 
	m_bEAN128 = m_chkEAN128.GetCheck(); 
	m_bEAN13 = m_chkEAN13.GetCheck(); 
	m_bEAN8 = m_chkEAN8.GetCheck(); 
	m_bUPCA = m_chkUPCA.GetCheck(); 
	m_bUPCE = m_chkUPCE.GetCheck(); 
	m_bIT25 = m_chkIT25.GetCheck(); 

	CString tmp;

	// Threshold value
	m_txtThreshold.GetWindowText(tmp);
	m_nThreshold = strtoul(tmp, 0, 10);

	// Quiet zone value
	m_cbxQuietZone.GetWindowText(tmp);
	m_dQuietZone = (float)strtoul(tmp, 0, 10);

	// Minimum bar height in CMs
	m_cbxMinHeight.GetWindowText(tmp);
	m_dMinBarHeight = (float)strtoul(tmp, 0, 10);

	// Maximum bar height in CMs
	m_cbxMaxHeight.GetWindowText(tmp);
	m_dMaxBarHeight = (float)strtoul(tmp, 0, 10);

	if (m_cbxFileLocation.GetCurSel() == 0)
		// file in memory
		m_bDiskFile = FALSE;
	else
		// file on disk
		m_bDiskFile = TRUE;

}

void CDemoDlg::OnButtonImgApply() 
{
	// TODO: Add your control notification handler code here
	CString tmp;
	CString ErrorMsg = "";

	// Region's left value
	m_txtRLeft.GetWindowText(tmp);
	m_nRLeft = strtoul(tmp, 0, 10);
	if ((m_nRLeft < 0) || (m_nRLeft >= m_nImgWidth))
	{
		ErrorMsg = ErrorMsg + "Left value must be between 0 and image width minus 1\r\n";
		m_nRLeft = 0;
	}

	// Region's top value
	m_txtRTop.GetWindowText(tmp);
	m_nRTop= strtoul(tmp, 0, 10);
	if ((m_nRTop < 0) || (m_nRTop >= m_nImgHeight))
	{
		ErrorMsg = ErrorMsg + "Left value must be between 0 and image height minus 1\r\n";
		m_nRTop = 0;
	}

	// Region's right value
	m_txtRWidth.GetWindowText(tmp);
	m_nRRight = m_nRLeft + strtoul(tmp, 0, 10) - 1;
	if ((m_nRRight < m_nRLeft) || (m_nRRight >= m_nImgWidth))
	{
		ErrorMsg = ErrorMsg + "Right value must be between left value and image width minus 1\r\n";
		m_nRRight = m_nImgWidth - 1;
	}

	// Region's bottom value
	m_txtRHeight.GetWindowText(tmp);
	m_nRBottom = m_nRTop + strtoul(tmp, 0, 10) - 1;
	if ((m_nRBottom < m_nRTop) || (m_nRBottom >= m_nImgHeight))
	{
		ErrorMsg = ErrorMsg + "Bottom value must be between top value and image height minus 1\r\n";
		m_nRBottom = m_nImgHeight - 1;
	}

	if (strlen(ErrorMsg) > 0)
		MessageBox(ErrorMsg, "Error", 0);
}


void CDemoDlg::OnSelchangeCombo1Pages() 
{
	// TODO: Add your control notification handler code here
	CString tmp;
	if (m_nImgFormat == 2 || m_nImgFormat == 6)
	{
		// Page option for TIF or GIF
		m_nPageOption = m_cbxPages.GetCurSel();

		int result = De1DSetPage(m_nPageOption);

		if (result == 1)
		{
			WORD w, h;
			De1DGetImgSize(&w, &h);

			CString tmp;
			tmp.Format("%d", w);
			m_txtImgWidth.SetWindowText(tmp);
			m_txtRWidth.SetWindowText(tmp);

			tmp.Format("%d", h);
			m_txtImgHeight.SetWindowText(tmp);
			m_txtRHeight.SetWindowText(tmp);

			m_txtRLeft.SetWindowText("0");
			m_txtRTop.SetWindowText("0");

			m_nRLeft = 0;
			m_nRTop = 0;
			m_nRRight = w - 1;
			m_nRBottom = h - 1;

			m_nImgWidth = w;
			m_nImgHeight = h;
		}
	}
}


