// DemoDlg.h : header file
//

#if !defined(AFX_DEMODLG_H__F0BCE00E_F676_4380_9C17_4B46EC809C37__INCLUDED_)
#define AFX_DEMODLG_H__F0BCE00E_F676_4380_9C17_4B46EC809C37__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

class CDemoDlg : public CDialog
{
// Construction
public:
	CDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDemoDlg)
	enum { IDD = IDD_DEMO_DIALOG };
	CButton	m_btnImgInfoApply;
	CComboBox	m_cbxFileLocation;
	CButton	m_chkEAN8;
	CButton	m_chkEAN13;
	CEdit	m_txtRHeight;
	CEdit	m_txtRWidth;
	CEdit	m_txtRTop;
	CEdit	m_txtRLeft;
	CComboBox	m_cbxPages;
	CEdit	m_txtImgPages;
	CEdit	m_txtImgHeight;
	CEdit	m_txtImgWidth;
	CComboBox	m_cbxMaxHeight;
	CComboBox	m_cbxMinHeight;
	CComboBox	m_cbxQuietZone;
	CEdit	m_txtThreshold;
	CButton	m_chkIT25;
	CButton	m_chkUPCE;
	CButton	m_chkUPCA;
	CButton	m_chkEAN128;
	CButton	m_chkCode128;
	CButton	m_chkCode39;
	CEdit	m_BarcodeInfo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	BOOL	m_bEAN8;
	BOOL	m_bEAN13;
	BOOL	m_bIT25;
	BOOL	m_bUPCE;
	BOOL	m_bUPCA;
	BOOL	m_bEAN128;
	BOOL	m_bCode128;
	BOOL	m_bCode39;
	int		m_nThreshold;
	double 	m_dQuietZone;
	double 	m_dMinBarHeight;
	double 	m_dMaxBarHeight;
	BOOL	m_bDiskFile;

	WORD	m_nImgFormat;
	WORD	m_nPageOption;
	WORD	m_nRLeft;
	WORD	m_nRTop;
	WORD	m_nRRight;
	WORD	m_nRBottom;
	WORD	m_nImgWidth;
	WORD	m_nImgHeight;
	WORD GetImgFormat(LPCSTR ImgName);

	// Generated message map functions
	//{{AFX_MSG(CDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnBtnSoApply();
	afx_msg void OnButtonScan();
	afx_msg void OnButtonOpen();
	afx_msg void OnButtonImgApply();
	afx_msg void OnSelchangeCombo1Pages();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEMODLG_H__F0BCE00E_F676_4380_9C17_4B46EC809C37__INCLUDED_)
